     Program Alpha;
   {...................................................}

     Uses Crt,Types,Base,User,Picture;

{-----------------------------------------------------------------------}
   Var   {--------------------------------------------------------------}

                Mode: String[4];
                 i,k: Integer;
{-----------------------------------------------------------------------}

     Begin
     With Sys do

     REPEAT
   {...................................................}

     GetKeyBoard;
     if RGS[7] =0 then Menu;
     UserView;

   {....................................................................}

     if RGS[1]> 0 then
     begin
   {....................................................................}

      Mode:=ModeStr[Switch[SW.Mode].Last];

{=============================================== SYSTEM MODES ==========}

      if  ((Mode ='AUTO') or (Mode ='STEP'))
      and (GetButton(SB.CycleOn)> 0) then
      begin
       k:=0;
       if (PrgState =2) and (not Profil) then k:=20;
       for i:=1 to iA do With Axis[i]^ do if not Init then
       begin Message[3]^[26]:=Letter; k:=3; Break; end;

       if ReadCD(32) =0 then CycleError.Next:=136;
       if ReadCD(30) =0 then CycleError.Next:=135;
       if ReadCD(50) =0 then CycleError.Next:=134;
       if (ReadCD(53)= 0) or (ReadCD(52) =1) then CycleError.Next:=131;
       GetBoxCode;
       if Spindle^.iBox =0 then CycleError.Next:=130;

       if RunTimeError.Next or CycleError.Next> 0 then k:=8;
       if k> 0 then Send.Next:=k else
       if Mode ='AUTO' then Process(1) else Process(2);
      end;
   {....................................................................}

      if (Mode ='MDI ')
      and StrRead(0,1,79,$0F,0,1,ProcMDI,StrMDI^) then
      Process(3);
   {....................................................................}

      if (Mode ='HOME') and (GetButton(SB.CycleOn)> 0) then
      begin
       if GetAxisCode then Continue;
       With Axis[iAxis]^ do
       begin
        With UserStack(1)^.Stack do
        begin
         Cod:=0; gA:=1; bF:=FHome.High; nUAO:=0; AX0:=TableUAO[0]^;
         With Limit do D[iAxis]:=2*(High-Low);
        end;
        With UserStack(2)^.Stack do
        begin D[iAxis]:=-D[iAxis]; bF:=FHome.Low; end;
        With UserStack(3)^.Stack do
        begin D[iAxis]:=0; bF:=FHome.High; end;
        Init:=False; Process(4);
        if Init then
        begin Message[10]^[22]:=Letter; Send.Next:=10; end;
       end;
      end;
   {....................................................................}
{================================================= USER MODES ==========}

      if  (Mode ='MANU') and (GetButton(SB.CycleOn)> 0) then
      begin
       if GetDirectCode or GetAxisCode then Continue;
       With UserStack(1)^.Stack do With Axis[iAxis]^.Limit do
       begin
        Cod:=0; gA:=0;
        if iDirect =1 then D[iAxis]:=High else D[iAxis]:=Low;
       end;
       Process(5);
       With Axis[iAxis]^ do
       if (C0 =Limit.High) or (C0 =Limit.Low) then Send.Next:=7;
      end;
   {.................................................................}
   {Technology}
   {.................................................................}

      if (Mode ='JOG ') and (GetButton(SB.CycleOn)> 0) then
      begin
       if GetDirectCode or GetAxisCode then Continue;
       With UserStack(1)^.Stack do With Axis[iAxis]^ do
       begin
        Cod:=1; gA:=1; bF:=FWork.Low;
        if iDirect =1 then D[iAxis]:=D[iAxis]+JOG/Scale
        else D[iAxis]:=D[iAxis]-JOG/Scale;
        With Limit do
        begin
         if D[iAxis]> High then D[iAxis]:=High;
         if D[iAxis] <Low  then D[iAxis]:=Low ;
        end;
       end;
       Process(7);
       With Axis[iAxis]^ do
       if (C0 =Limit.High) or (C0 =Limit.Low) then Send.Next:=7;
      end;
   {....................................................................}

      if (Mode ='PROF') and (GetButton(SB.CycleOn)> 0) then
      begin
       if PrgState <2 then begin Send.Next:=17; Continue; end;
       if Profil      then begin Send.Next:=19; Continue; end;
       if GetAxisCode then Continue;

       if (Abs(HoldAxis[iAxis]-Axis[iAxis]^.C0) >eps) then
       begin
        With UserStack(1)^.Stack do
        begin
         Cod:=0; gA:=0; D[iAxis]:=HoldAxis[iAxis];
         if (iAxis =MainAxis) and
         (Axis[MainAxis]^.C0> HoldAxis[MainAxis]) then
         if (Axis[MainAxis]^.C0> HoldAxis[MainAxis]+10) then
         begin
          With UserStack(2)^.Stack do
          begin Cod:=1; gA:=1; bF:=FWork.Low; end;
          D[iAxis]:=D[iAxis]+10;
         end else begin Cod:=1; gA:=1; bF:=FWork.Low; end;
        end;
        Process(8);
       end;
       With Send do if Next <>4 then Send.Next:=18;
      end;
   {....................................................................}

      if (Mode ='ESC ') and (GetButton(SB.CycleOn)> 0) then
      begin
       ReSetState;
       ReSetStream(RunTimeError);
       ReSetStream(CycleError);
       ResetProgram(1);
       With UserStack(1)^.Stack do
       begin
        Cod:=$09; bM.Last[0]:=1; bM.Last[1]:=5;
        Process(9);
       end;
       Send.Next:=24;
      end;

{=======================================================================}
   {....................................................................}
   {Instrument}

      if Switch[8].Change then
      With UserStack(1)^.Stack do With bM do
      begin
       Cod:=$09; Last[0]:=1; Last[1]:=HFunction+Switch[8].Last;
       Process(10);
       Switch[8].Change:=False;
      end;

   {....................................................................}
   {Spindle}

      if (GetButton(SB.CycleOff) <0) and (Spindle^.Active <>0) then
      With UserStack(1)^.Stack do
      begin
       Cod:=$09; bM.Last[0]:=1; bM.Last[1]:=5;
       Process(11);
      end;

   {--------------------------------------------------------------------}

     Case KeyBoard[1] of

    {..............................................................}

        F5 : if Mode ='JOG ' then SetJOG;
       F10 : begin ReSetStream(Send); ReSetDis; end;

     AltF6 : begin
              if GetAxisCode Then Continue;
              SetUAO;
             end;
     AltF7 : begin
              if GetAxisCode Then Continue;
              Case iAxis Of
               1: ReSetAxis(78);
               2: ReSetAxis(79);
               3: ReSetAxis(80);
               4: ReSetAxis(77);
               5: ReSetAxis(82);
              end;
             end;
     AltF9 : ReSetState;
     AltF10: ReSetProgram(0);

    {..............................................................}

     end; {Case}
     end  {1}
     else
   {....................................................................}

     begin
      WriteNote(0);
      if GetButton(SB.MachineOn)> 0 then
      begin
       ReSetDACPort(0);
       ReSetPCLPort(0);
       ResetSpindle;
       if PrgState <2 then begin ReSetState; ReSetDis; end;
       ReSetVar;
       ReSetStream(Send);
       ReSetStream(CycleError);
       ReSetStream(RunTimeError);

       if Machine then
       begin
        WriteNote(1);
        RGS[1]:=1; RGS[7]:=0;
        Send.Next:=2;
       end else
       begin
        ReSetOutPort(0,0);
        FillChar(RGS,SizeOf(RGS),0);
       end;
      end;
     end; {0}

   {....................................................................}

     Case KeyBoard[1] of
      F1: Inform(False);
   AltF1: Inform(True);
      F2: SetUp(0);
      F3: Debug;
      F4: Edit;
      F6: ReadNote(0);
      F7: ReadNote(1);
      F9: begin
           ReSetStream(CycleError);
           ReSetStream(RunTimeError);
          end;
      F8: if PrgState> 0 then With PrgTime do
          begin
           Active:=Active xor 1; Change:=True;
          end;
   AltF8: if PrgState> 0 then With PrgTime do
          begin
           FillChar(Hour,3,0);
           Change:=True; Send.Next:=76;
          end;

     end;

     Until (KeyBoard[1] =#16) or (ReadCD(1) =0);
   {...................................................}

     Sys.Destroy;

{-----------------------------------------------------------------------}
     End.