
    Unit Picture;

{-----------------------------------------------------------------------}
                               INTERFACE
{-----------------------------------------------------------------------}

    Procedure Menu;

{-----------------------------------------------------------------------}
                            IMPLEMENTATION
{-----------------------------------------------------------------------}

    Uses  Crt,Types,Base;

    Var  {--------------------------------------------------------------}

              i: Integer;
            s: String[8];
    {................................................}

{-----------------------------------------------------------------------}

    Procedure RightPanel;
    Var  i,Y: Byte;

    Begin
     With Sys do
     begin
      RGS[12]:=RGS[12] and 3;
      for i:=5 to 21 do begin Place(45,i); Write(SEL:33); end;
      TextAttr:=$0F; Place(71,3); Write(Succ(RGS[12]));
      Case RGS[12] Of
   0:  begin
        WriteChar(71, 3,1,'1');
        WriteChar(46,19,1,'D');
        WriteChar(65,19,1,'L');
        WriteChar(46,20,1,'G');
        WriteChar(46,21,1,'M');
        TextAttr:=$07;
        WriteChar(45,9,33,HL1);
        WriteChar(45,18,33,HL1);
        Place(46,5); Write('FQC');
        Place(61,5); Write('USB');
        Place(70,5); Write('TMR');
        Place(46,6); Write('FWC');
        Place(61,6); Write('URL');
        Place(70,6); Write('UTS');
        Place(46,7); Write('FVR');
        Place(61,7); Write('UVR');
        Place(70,7); Write('USO');
        Place(46,8); Write('JOG');
        Place(61,8); Write('UCV');
        Place(70,8); Write('UAO');
        Place(46,12); Write('ணࠬ');
        Place(46,13); Write('ணࠬ');
        Place(46,14); Write(' RPT');
        Place(46,15); Write('ᥣ ஢');
        Place(46,16); Write('騩 ');
        RGS[9]:=0;
       end;
   2:  begin
        TextAttr:=$07;
        Place(46,5); Write('室 ᨣ:');
        Y:=7;
        for i:=1 to nINPCard do
        begin
         Place(46,Y);
         TextAttr:=$0F; Write(i);
         TextAttr:=$02; Write('  01234567  ');
         TextAttr:=$06; Write('01234567  ');
         TextAttr:=$04; Write('01234567  ');
         Inc(Y,2);
        end;
        TextAttr:=$07;
        Place(46,Succ(Y)); Write('室 ᨣ:');
        Inc(Y,3);
        for i:=1 to nOUTCard do
        begin
         Place(46,Y);
         TextAttr:=$0F; Write(i);
         TextAttr:=$02; Write('  01234567  ');
         TextAttr:=$06; Write('01234567  ');
         TextAttr:=$04; Write('01234567  ');
         Inc(Y,2);
        end;
       end;
      end; {Case}
      RGS[8]:=0;
     end;  {Sys}
    End;

{-----------------------------------------------------------------------}

    Procedure View; far;

    Var {...............................................}

         i,j,Y,Len: Byte;
                U,U0: PtrStack;

  {...................................................................}

    Begin

    With Sys do With UStart^.Stack do
    begin

     if RGS[1]> 0 then
     begin

  {......................................................................}
  {Right panel}

      if RGS[12]> 3 then RightPanel;
      TextAttr:=$07;

  {......................................................................}
  {Change block}

      if RGS[8] =0 then
      begin
       for i:= 1 to iA do
       begin
        Place(19,11+i);
        if i =MainAxis then Write(D[i]*Axis[i]^.Scale-AX0[i]-DL[1]:9:3)
        else Write(D[i]*Axis[i]^.Scale-AX0[i]:9:3);
       end;

       Place(23,19);
       if gA> 0 then Write(bF:5:0) else Write(FWork.High:5:0);
       Place(23,20); Write(bS:5);
       Place(11,21); Write(T0:2,'.',nDL:2);
       Place(23,21); Write(bT:2,'.',bD:2);

       Case RGS[12] Of
    0: begin
        Place(50,19); Write(DL[0]:8:3);
        Place(69,19); Write(DL[1]:8:3);
        Place(71,16); Write(N:6);
        Place(49,20); Write(gA,gB:3,gC:3,gD:3);
        if gK> 0 then Write(gK:3) else Write(gE:3);
        Write(gF:3,gG:3,gH:3,gL:3,gN:3);
        With Spindle^ do
        begin
         Place(49,21);
         if Active> 0 then Write('3 4') else Write(Active+5,' 4');
         if Transmit =0 then Write('0') else
         if iBox =0 then Write('?') else Write(iBox);
        end;
        if (Liquid> 0) and (ReadCD(Liquid)> 0) then
        Write(' 08') else
        if (Air> 0) and (ReadCD(Air)> 0) then
        Write(' 07') else Write(' 09');
       end;

    1: if PrgState =0 then
       begin
        Y:=5;
        repeat
         Place(46,Y); Write(SEL:31); Inc(Y);
        until Y> 21;
        Place(51,13); Write('ணࠬ  㦥');
       end else
       begin
        if RGS[4] In [1,2] then U0:=UStart else
        if PrgState =2 then U0:=UHold^.USucc else U0:=BRing^.USucc;
        Y:=13; U:=U0; TextAttr:=$47;

        repeat
         Place(46,Y);
         if U =PrgEnd^.USucc then Write(SEL:31) else
         With U^.Stack do
         begin
          if US =U^.USucc^.Stack.US then begin U:=U^.USucc; Continue; end;
          Len:=Length(US^.S);
          if Len> 61 then Len:=61;
          if Len> 31 then
          begin
           Write(Copy(US^.S,1,31));
           Inc(Y); if Y> 21 then Break; Place(46,Y);
           Write(SEL,Copy(US^.S,32,Len-31));
           if Len <61 then Write(SEL:61-Len);
          end else
          begin
           Write(US^.S);
           if Len <31 then Write(SEL:31-Len);
          end;
          U:=U^.USucc;
         end;
         Inc(Y); TextAttr:=$07;
        until Y> 21;

        Y:=12; U:=U0^.UPred;
        repeat
         Place(46,Y);
         if U =BRing then Write(SEL:31) else With U^.Stack do
         begin
          if US =U^.USucc^.Stack.US then
          begin U:=U^.UPred; Continue; end;
          Len:=Length(US^.S);
          if Len> 61 then Len:=61;
          if Len> 31 then
          begin
           Write(SEL,Copy(US^.S,32,Len-31));
           if Len <61 then Write(SEL:61-Len);
           Dec(Y); if Y <5 then Break; Place(46,Y);
           Write(Copy(US^.S,1,31));
          end else
          Write(US^.S,SEL:31-Len);
          U:=U^.UPred;
         end;
         Dec(Y);
        until Y <5;
       end;
      end; {Case}

     {.............................................}

       RGS[8]:=1;
      end;
  {.......................................................................}
  {Screen 2}

       if (RGS[12] =2) and (RGS[14] =0) then
       begin
        Y:=8;
        for i:=1 to nINPCard do With INP[i]^ do
        begin
         Place(46,Y); Write(SEL:3);
         for j:=1 to nCanal do
         begin
          for Len:=0 to 7 do
          Write(Port[Canal[j]] shr Len and 1);
          Write(SEL:2);
         end;
         Inc(Y,2);
        end;
        Inc(Y,3);
        for i:=1 to nOUTCard do With OUT[i]^ do
        begin
         Place(46,Y); Write(SEL:3);
         for j:=1 to nCanal do
         begin
          for Len:=0 to 7 do
          Write(Port[Canal[j]] shr Len and 1);
          Write(SEL:2);
         end;
         Inc(Y,2);
        end;

     {.............................................}

        RGS[14]:=1;
       end;

  {.......................................................................}
  {Control}

      if (RGS[9] or RGS[12] =0) then
      begin
        With FWork do
        begin
         Place(51,5); Write(High:7:2);
         Place(51,6); Write(Low:7:2);
        end;
        Place(51,7); Write(FUVR:7:2);
        Place(50,8); Write(JOG:8:3);

        With UCod do
        begin
         Place(66,5); Write(USB);
         Place(66,6); Write(URL);
         Place(66,7); Write(UVR);
         Place(66,8); Write(UCV);
         Place(74,5); Write(Round(Timer.TMR.Value):3);
         Place(76,6); Write(UTS);
         Place(76,7); Write(USO);
         Place(75,8); Write(nUAO:2);
        end;

        Place(63,12); With Strings do
        if Run ='' then Write('-':14) else Write(Run:14);

        Place(69,13); if US^.IndexCLS =0 then Write('-':8) else
        begin
         Move(TableCLS[US^.IndexCLS].Name,s[1],8);
         for i:=8 downto 1 do if s[i]> SEL then Break;
         s[0]:=Char(i); Write(s:8);
        end;

        Place(69,14); Write(REP:6,'.',nREP);
        Place(71,15); Write(ESE:6);

        RGS[9]:=1;
       end;

  {...............................................................}
  {Correct}

     {...................................................}
     {F}

       With Switch[SW.F] do With CorrectF do
       if Change then
       begin
        Place(34,19);
        Value:=PerSet+Last*PerInc; Write(Value:3);
        Change:=False;
       end;
     {...................................................}
     {S}

       if (SW.S> 0) and (Switch[SW.S].Change) then
       With Spindle^ do With CorrectS do
       begin
        Value:=PerSet+Switch[SW.S].Last*PerInc;
        Place(34,20); Write(Value:3);
        PutS:=SetS*Value Div 100;
        if (Active <>0) and (iBox> 0) then With Box[iBox] do
        begin
         if (PutS <Low) or (PutS> High) then
         begin
          if PutS <Low then PutS:=Low else PutS:=High;
          Send.Next:=12;
         end;
         PutD:=Round(Dkv(PutS,nA)*Zub*Active);
        end;
        Place(11,20); Write(PutS:5);
        Switch[SW.S].Change:=False;
       end;

  {...............................................................}
  {RunTime}

      if RGS[10] =0 then
      begin

       Place(11,19); Write(Vector*60:5:0);
       With UCod do for i:=1 to iA do With Axis[i]^ do
       begin
        Place(7,11+i);
        Case UCV Of
     0:  if i =MainAxis then Write(C0*Scale-AX0[i]-DL[1]:9:3)
         else Write(C0*Scale-AX0[i]:9:3);
     1:  if i =MainAxis then
         Write((D0+(DScrew+DShake)*eps)*Scale-AX0[i]-DL[1]:9:3)
         else Write((D0+(DScrew+DShake)*eps)*Scale-AX0[i]:9:3);
     2:  Write(Lost*eps*Scale:9:3);
     3:  if i =MainAxis then
         Write(D0*Scale-AX0[i]-DL[1]:9:3)
         else Write(D0*Scale-AX0[i]:9:3);
        end;
        Place(30,11+i); Write((D[i]-C0)*Scale:9:3);
       end;

       RGS[10]:=1;
      end;
  {.............................................................}
  {Message}

      With Send do if Next <>Last then
      begin
       With Timer.Message do Count:=Store;
       Last:=Next; Place(3,8); Write(Message[Last]^);
      end;
  {.............................................................}
  {Dis}

      With SendDis do if Change then
      begin
       TextAttr:=$02; Place(3,7); Write(S);
       Change:=False;
      end;
  {............................................................}
  {State}

      if RGS[11] =0 then
      begin
       TextAttr:=$0F; Place(15,3);
       if RGS[4]> 0 then Write('RUN ') else
       if PrgState =2 then Write('HOLD') else Write('IDLE');

       RGS[11]:=1;
      end;
  {.............................................................}
  {Mode}

      With Switch[SW.Mode] do if Change then
      begin
       j:=Last;
       if (RGS[4] =0)
       or ((RGS[4] =1) and (ModeStr[j] ='STEP'))
       or ((RGS[4] =2) and (ModeStr[j] ='AUTO')) then
       begin
        TextAttr:=$0F; Place(31,3); Write(ModeStr[j]);
        if ModeStr[j] <>'MDI ' then
        begin TextAttr:=$0E; Place(0,1); Write(LAB,SEL:79); end;
        if RGS[4]> 0 then
        begin RGS[4]:=RGS[4] xor 3; RGS[5]:=2; end
        else Switch[SW.Axis].Change:=True;
       end;
       Change:=False;
      end;
  {.............................................................}
  {Axis}

      if RGS[4] =0 then With Switch[SW.Axis] do
      if Change then
      begin
       j:=Switch[SW.Mode].Last; Y:=0;
       if (ModeStr[j] ='MANU') or (ModeStr[j] ='JOG ')
       or (ModeStr[j] ='HOME') or (ModeStr[j] ='PROF') then Y:=1;
       for i:=1 to iA do
       begin
        if Axis[i]^.Init then TextAttr:=$0E else TextAttr:=$06;
        if (Y> 0) and ((1 shl Pred(i)) =Last) then
        TextAttr:=TextAttr Or Blink;
        WriteChar(3,11+i,1,Axis[i]^.Letter);
       end;
       Change:=False;
      end;
  {.............................................................}
  {CycleError}

      With CycleError do if Next <>Last then
      begin
       Last:=Next; TextAttr:=$0C;
       Place(3,6); Write(Error[Last]^);
      end;

     end; {1}
  {.............................................................}
  {PrgTime}

    With PrgTime do if Change then
    begin
     TextAttr:=$34; Place(58,0);
     if (Active> 0) and (PrgState> 0) then
     Write(Hour,':',Minute,':',Second,SEL:2)
     else Write(SEL:10);
     Change:=False;
    end;

  {.............................................................}
  {RunTimeError}

    With RunTimeError do if Next <>Last then
    begin
     if RGS[1]> 0 then TextAttr:=$0C else TextAttr:=$1F;
     Last:=Next; Place(3,5); Write(Error[Last]^);
    end;
  {.........................................................}

   end;
   End;

{-----------------------------------------------------------------------}

   Procedure Menu;
   var
           i: Integer;
   {...................................................}

   Begin

   With Sys do
   begin

  {.......................................................................}
  {CO80}

   begin
    TextAttr:=$30;
    WriteChar(0,0,80,SEL);
    WriteChar(70,0,1,':'); WriteChar(73,0,1,':'); ViewClock;

    Place(0,24);
    Write('':16,'⠭':20,'':18,'':19);
    ClrEol;
    TextAttr:=$34;
    Place( 6,24); Write('F1-');
    Place(23,24); Write('F2-');
    Place(43,24); Write('F3-');
    Place(61,24); Write('F4-');

    if RGS[1] =0 then
    begin
   {...................................................}
   {0}

     Frame(0,1,79,23,$17,$17,$17,0,'');
     Frame(1,3,78, 6,$1B,$17,$17,0,' 饭 ');
     Place(3,8); Write(' ');

     if PrgState <2 then
     begin
      TextAttr:=$1F; Place(15,12);
      Write('⥬ ࠢ 孮᪨ 㤮');
      TextAttr:=$1E; Place(35,14); Write('<  >');
     end
     else With UHold^.USucc^.Stack do
     begin
      Frame(1,10,78,22,$1B,$17,$1F,0,' ਩ 뢠 ணࠬ ');
      Place(3,12); Write(' ணࠬ');
      Place(3,14); Write(' ');
      Place(3,15); Write('ᥣ ஢ ESE');
      Place(3,16); Write(' UAO');
      Place(3,17); Write(' ४');
      Place(3,18); Write('ணࠬ  SUB');
      Place(3,19); Write('   RPT');
      Place(3,20); Write('஢ 横 LEV');

      Place(40,12); Write('     actual    program     UAO');
      for i:=1 to iA do WriteChar(40,13+i,1,Axis[i]^.Letter);
      WriteChar(40,20,1,'D');
      WriteChar(61,20,1,'L');
      TextAttr:=$17;

      Place(24,12); With Strings do Write(Run);
      Place(25,14); Write(N:6);
      Place(25,15); Write(ESE:6);
      Place(25,16); Write(nUAO:6);
      Place(25,17); Write(nDL:6);

      Place(23,18);
      if US^.IndexCLS =0 then Write('-':8) else
      begin
       Move(TableCLS[US^.IndexCLS].Name,s[1],8);
       for i:=8 downto 1 do if s[i]> SEL then Break;
       s[0]:=Char(i); Write(s:8);
      end;

      Place(25,19); Write(REP:6);
      Place(25,20); Write(nREP:6);
      for i:=1 to iA do With Axis[i]^ do
      begin
       Place(45,13+i);
       Write(HoldAxis[i]*Scale:9:3,D[i]*Scale:11:3,AX0[i]:11:3);
      end;
      Place(45,20); Write(DL[0]:9:3);
      Place(67,20); Write(DL[1]:9:3);
     end;
    end else
   {...................................................}
   {1}

    begin
     Frame(0,2,79,23,$07,$07,$07,1,'');
     WriteChar(2,4,40,HL1);
     WriteChar(2,9,40,HL1);
     for i:=3 to 22 do WriteChar(43,i,1,#186);

     Place(12,10); Write('','':12,'⮪':11);
     WriteChar(38,19,1,'%');
     WriteChar(38,20,1,'%');
     Place(9, 3); Write(' [    ]     [    ]');
     Place(64, 3); Write('࠭ [ ]');
     WriteChar(2,18,40,HL1);
     WriteChar(45,4,33,HL1);
     TextAttr:=$0A;
     WriteChar(3,19,1,'F');
     WriteChar(3,20,1,'S');
     WriteChar(3,21,1,'T');

     RightPanel;
    end;
   end;

  {...................................................}
  {flags}

     TextAttr:=$0F; RGS[7]:=1;
     RGS[8]:=0; RGS[9]:=0; RGS[10]:=0; RGS[11]:=0;
     Switch[SW.Mode].Change:=True;
     Switch[SW.Axis].Change:=True;
     Switch[SW.F].Change:=True;
     Switch[SW.S].Change:=True;
     PrgTime.Change:=True;
     SendDis.Change:=True;
     Send.Last:=ff;
     CycleError.Last:=ff;
     RunTimeError.Last:=ff;
    end; {Sys}
    End;

{-----------------------------------------------------------------------}
{                                INIT                                   }
{-----------------------------------------------------------------------}

   Begin
   With Sys do
   begin

     UserView:=View;
  {.......................................................}

   end;

{-----------------------------------------------------------------------}


   End.